 processor 6502

	ORG $801
	.byte    $0E, $08, $0A, $00, $9E, $20, $28
	.byte   $32,$30,$36,$34
	.byte    $29, $00, $00, $00

	ORG $810
Example3
	jmp block26777
y	dc.b	0
i	dc.b	0
j	dc.b	0
time	dc.b	0
k	dc.b	0
l	dc.b	0
h	dc.b	0
frame	dc.b	0
kp	= $02
zp	= $04
p1	= $08
	
	
	; ***********  Defining procedure : init16x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
divisor = $4C     ;$59 used for hi-byte
dividend = $4E	  ;$fc used for hi-byte
remainder = $50	  ;$fe used for hi-byte
result = $4E ;save memory by reusing divident to store the result
divide16x8	lda #0	        ;preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        ;repeat for each bit: ...
divloop16	asl dividend	;dividend lb & hb*2, msb -> Carry
	rol dividend+1
	rol remainder	;remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor	;substract divisor to see if it fits in
	tay	        ;lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip16	;if carry=0 then divisor didn't fit in yet
	sta remainder+1	;else save substraction result as new remainder,
	sty remainder
	inc result	;and INCrement result cause divisor fit in 1 times
skip16	dex
	bne divloop16
	rts
	rts
	
	
	; ***********  Defining procedure : init16x8mul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
mul16x8_num1Hi = $4C
mul16x8_num1 = $4E
mul16x8_num2 = $50
mul16x8_procedure
	lda #$00
	ldy #$00
	sty mul16x8_num1Hi  ; remove this line for 16*8=16bit multiply
	beq mul16x8_enterLoop
mul16x8_doAdd
	clc
	adc mul16x8_num1
	tax
	tya
	adc mul16x8_num1Hi
	tay
	txa
mul16x8_loop
	asl mul16x8_num1
	rol mul16x8_num1Hi
mul16x8_enterLoop  ; accumulating multiply entry point (enter with .A=lo, .Y=hi)
	lsr mul16x8_num2
	bcs mul16x8_doAdd
	bne mul16x8_loop
	rts
mul16x8_def_end
	rts
	
	
	; ***********  Defining procedure : init8x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
div8x8_c = $4C
div8x8_d = $4E
div8x8_e = $50
	; Normal 8x8 bin div
div8x8_procedure
	lda #$00
	ldx #$07
	clc
div8x8_loop1 rol div8x8_d
	rol
	cmp div8x8_c
	bcc div8x8_loop2
	sbc div8x8_c
div8x8_loop2 dex
	bpl div8x8_loop1
	rol div8x8_d
	lda div8x8_d
	rts
div8x8_def_end
	rts
	
	
	; ***********  Defining procedure : initeightbitmul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
multiplier = $4C
multiplier_a = $4E
multiply_eightbit
	cpx #$00
	beq mul_end
	dex
	stx $4E
	lsr
	sta multiplier
	lda #$00
	ldx #$08
mul_loop
	bcc mul_skip
mul_mod
	adc multiplier_a
mul_skip
	ror
	ror multiplier
	dex
	bne mul_loop
	ldx multiplier
	rts
mul_end
	txa
	rts
multiply_eightbit15573
	rts
	
	
	; ***********  Defining procedure : RenderMovie
	;    Procedure type : User-defined procedure
	
 ; Temp vars section
 ; Temp vars section ends
RenderMovie

	; Assigning single variable : zp
	lda #4
	ldx #4
	sta zp
	stx zp+1
	; Assigning single variable : j
	lda #0
	sta j
	; Assigning single variable : kp
	
	; Generic 16 bit op
	ldy #0
	lda #<table
	ldy #>table
	
rightvarInteger_var13290 = $54
	sta rightvarInteger_var13290
	sty rightvarInteger_var13290+1
	
	; Mul 16x8 setup
	
	lda #48
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	ldy #0
	lda frame
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	; Low bit binop:
	clc
	adc rightvarInteger_var13290
	bcc wordAdd16512
	inc rightvarInteger_var13290+1
wordAdd16512
	sta rightvarInteger_var13290
	; High-bit binop
	tya
	clc
	adc rightvarInteger_var13290+1
	tay
	lda rightvarInteger_var13290
	
	sta kp
	sty kp+1
	; Assigning single variable : y
	lda #0
	sta y
for9161

	; Assigning single variable : l
	; Load pointer array
	ldy j
	lda (kp),y
	
	sta l
	; Assigning single variable : h
	; Load pointer array
	; LDA stuff
	; 8 bit binop
	; Add/sub where right value is constant number
	lda j
	clc
	adc #1
	 ; end add / sub var with constant
	
	tay
	lda (kp),y
	
	sta h
	; Assigning single variable : j
	; Optimizer: a = a +/- b
	lda j
	clc
	adc #2
	sta j
	; Assigning single variable : p1
	lda #<data
	ldx #>data
	sta p1
	stx p1+1
	; 
	; ****** Inline assembler section

			lda p1
			clc
			adc l
			bcc cont
			inc p1+1
cont:
			sta p1

			lda p1+1
			clc
			adc h
			sta p1+1
			
		
	
	; memcpy
	ldy #0
memcpy4031
	lda (p1),y
	sta (zp),y
	iny
	cpy #32
	bne memcpy4031
	lda #40
	clc
	adc zp
	bcc incscreenx12052
	inc zp +1
incscreenx12052
	sta zp

	inc y
	lda #24
	cmp y
	bne for9161
forLoopDone23655

	rts
	
	
	; ***********  Defining procedure : RasterMain
	;    Procedure type : User-defined procedure
	
RasterMain

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	jsr RenderMovie
	; Assigning single variable : frame
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda frame
	clc
	adc #1
	 ; end add / sub var with constant
	
	and #63
	 ; end add / sub var with constant
	
	sta frame
	inc time
	; CloseIRQ
	pla
	tay
	pla
	tax
	pla

	rti
block26777

	; Disable interrupts
	ldy #$7f    ; $7f = %01111111
	sty $dc0d   ; Turn off CIAs Timer interrupts
	sty $dd0d   ; Turn off CIAs Timer interrupts
	lda $dc0d   ; cancel all CIA-IRQs in queue/unprocessed
	lda $dd0d   ; cancel all CIA-IRQs in queue/unprocessed
	
	; Set Memory Config
	lda $01
	and #%11111000
	ora #%101
	sta $01
	; Clear screen with offset
	lda #32
	ldx #$00
clearloop1150
	sta $0000+$400,x
	sta $0100+$400,x
	sta $0200+$400,x
	sta $02e8+$400,x
	dex
	bne clearloop1150
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d020
	lda #0
	sta $d020
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d021
	sta $d021
	; Clear screen with offset
	lda #14
	ldx #$00
clearloop16941
	sta $0000+$d800,x
	sta $0100+$d800,x
	sta $0200+$d800,x
	sta $02e8+$d800,x
	dex
	bne clearloop16941
	lda $d018
	and #%11110001
	ora #8
	sta $d018
	; Regularcolor mode
	lda $d016
	and #%11101111
	sta $d016
	; RasterIRQ : Hook a procedure
	lda #0
	sta $d012
	lda #<RasterMain
	sta $fffe
	lda #>RasterMain
	sta $ffff
	; Enable raster IRQ
	lda $d01a
	ora #$01
	sta $d01a
	lda #$1B
	sta $d011
	asl $d019
	cli
	jmp * ; loop like (?/%

EndSymbol
	org $2000
charset
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///charsets/main.bin"
	org $2800
data
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///data/example3_screen.bin"
	org $b000
table
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///data/example3_table.bin"
