 processor 6502

	ORG $801
	.byte    $0E, $08, $0A, $00, $9E, $20, $28
	.byte   $32,$30,$36,$34
	.byte    $29, $00, $00, $00

	ORG $810
Example4
	jmp block41
i	dc.b	0
j	dc.b	0
k	dc.b	0
l	dc.b	0
y	dc.b	0
x	dc.b	0
frame	dc.b	0
time	dc.b	0
curBank	dc.b	0
zp	= $02
p1	= $04
p2	= $08
in	dc.w	
	
	
	; ***********  Defining procedure : init16x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
divisor = $4C     ;$59 used for hi-byte
dividend = $4E	  ;$fc used for hi-byte
remainder = $50	  ;$fe used for hi-byte
result = $4E ;save memory by reusing divident to store the result
divide16x8	lda #0	        ;preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        ;repeat for each bit: ...
divloop16	asl dividend	;dividend lb & hb*2, msb -> Carry
	rol dividend+1
	rol remainder	;remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor	;substract divisor to see if it fits in
	tay	        ;lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip16	;if carry=0 then divisor didn't fit in yet
	sta remainder+1	;else save substraction result as new remainder,
	sty remainder
	inc result	;and INCrement result cause divisor fit in 1 times
skip16	dex
	bne divloop16
	rts
	rts
	
	
	; ***********  Defining procedure : init16x8mul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
mul16x8_num1Hi = $4C
mul16x8_num1 = $4E
mul16x8_num2 = $50
mul16x8_procedure
	lda #$00
	ldy #$00
	sty mul16x8_num1Hi  ; remove this line for 16*8=16bit multiply
	beq mul16x8_enterLoop
mul16x8_doAdd
	clc
	adc mul16x8_num1
	tax
	tya
	adc mul16x8_num1Hi
	tay
	txa
mul16x8_loop
	asl mul16x8_num1
	rol mul16x8_num1Hi
mul16x8_enterLoop  ; accumulating multiply entry point (enter with .A=lo, .Y=hi)
	lsr mul16x8_num2
	bcs mul16x8_doAdd
	bne mul16x8_loop
	rts
mul16x8_def_end
	rts
	
	
	; ***********  Defining procedure : init8x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
div8x8_c = $4C
div8x8_d = $4E
div8x8_e = $50
	; Normal 8x8 bin div
div8x8_procedure
	lda #$00
	ldx #$07
	clc
div8x8_loop1 rol div8x8_d
	rol
	cmp div8x8_c
	bcc div8x8_loop2
	sbc div8x8_c
div8x8_loop2 dex
	bpl div8x8_loop1
	rol div8x8_d
	lda div8x8_d
	rts
div8x8_def_end
	rts
	
	
	; ***********  Defining procedure : initeightbitmul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
multiplier = $4C
multiplier_a = $4E
multiply_eightbit
	cpx #$00
	beq mul_end
	dex
	stx $4E
	lsr
	sta multiplier
	lda #$00
	ldx #$08
mul_loop
	bcc mul_skip
mul_mod
	adc multiplier_a
mul_skip
	ror
	ror multiplier
	dex
	bne mul_loop
	ldx multiplier
	rts
mul_end
	txa
	rts
multiply_eightbit18467
	rts
	
	
	; ***********  Defining procedure : SetScreen
	;    Procedure type : User-defined procedure
	
 ; Temp vars section
 ; Temp vars section ends
SetScreen

	; Assigning single variable : p1
	
	; Generic 16 bit op
	ldy #0
	lda #<screen
	ldy #>screen
	
rightvarInteger_var15724 = $54
	sta rightvarInteger_var15724
	sty rightvarInteger_var15724+1
	
	; Mul 16x8 setup
	
	lda #250
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	ldy #0
	lda frame
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	; Low bit binop:
	clc
	adc rightvarInteger_var15724
	bcc wordAdd26500
	inc rightvarInteger_var15724+1
wordAdd26500
	sta rightvarInteger_var15724
	; High-bit binop
	tya
	clc
	adc rightvarInteger_var15724+1
	tay
	lda rightvarInteger_var15724
	
	sta p1
	sty p1+1
	; Assigning single variable : p1
	
	; Generic 16 bit op
	ldy #0
	; integer assignment NodeVar
	ldy p1+1 ; next one ; optimized, look out for bugs
	lda p1
rightvarInteger_var26962 = $54
	sta rightvarInteger_var26962
	sty rightvarInteger_var26962+1
	
	; Right is PURE NUMERIC
	; 16 bit mul or div
	; Mul 16x8 setup
	
	ldy #0
	lda frame
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	lda #250
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	; Low bit binop:
	clc
	adc rightvarInteger_var26962
	bcc wordAdd11478
	inc rightvarInteger_var26962+1
wordAdd11478
	sta rightvarInteger_var26962
	; High-bit binop
	tya
	clc
	adc rightvarInteger_var26962+1
	tay
	lda rightvarInteger_var26962
	
	sta p1
	sty p1+1
	; Assigning single variable : p1
	
	; Generic 16 bit op
	ldy #0
	; integer assignment NodeVar
	ldy p1+1 ; next one ; optimized, look out for bugs
	lda p1
rightvarInteger_var28145 = $54
	sta rightvarInteger_var28145
	sty rightvarInteger_var28145+1
	
	; Right is PURE NUMERIC
	; 16 bit mul or div
	; Mul 16x8 setup
	
	ldy #0
	lda frame
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	lda #250
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	; Low bit binop:
	clc
	adc rightvarInteger_var28145
	bcc wordAdd24464
	inc rightvarInteger_var28145+1
wordAdd24464
	sta rightvarInteger_var28145
	; High-bit binop
	tya
	clc
	adc rightvarInteger_var28145+1
	tay
	lda rightvarInteger_var28145
	
	sta p1
	sty p1+1
	; Assigning single variable : p1
	
	; Generic 16 bit op
	ldy #0
	; integer assignment NodeVar
	ldy p1+1 ; next one ; optimized, look out for bugs
	lda p1
rightvarInteger_var9961 = $54
	sta rightvarInteger_var9961
	sty rightvarInteger_var9961+1
	
	; Right is PURE NUMERIC
	; 16 bit mul or div
	; Mul 16x8 setup
	
	ldy #0
	lda frame
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	lda #250
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	; Low bit binop:
	clc
	adc rightvarInteger_var9961
	bcc wordAdd23281
	inc rightvarInteger_var9961+1
wordAdd23281
	sta rightvarInteger_var9961
	; High-bit binop
	tya
	clc
	adc rightvarInteger_var9961+1
	tay
	lda rightvarInteger_var9961
	
	sta p1
	sty p1+1
	; Assigning single variable : p2
	lda #0
	ldx #4
	sta p2
	stx p2+1
	; Binary clause Simplified: EQUALS
	lda curBank
	; Compare with pure num / var optimization
	bne elsedoneblock4827
ConditionalTrueBlock2995
	; Assigning single variable : p2
	lda #0
	ldx #68
	sta p2
	stx p2+1
elsedoneblock4827
	; Copy full screen
	lda p1
	sta $4C
	lda p1+1
	sta $4C+1
	lda p2
	sta $4E
	lda p2+1
	sta $4E+1
	; CopyFullscreen with pointers
	ldx #3
outer14604
	ldy #0
inner3902
	lda ($4C),y
	sta ($4E),y
	dey
	bne inner3902
	inc $4C+1
	inc $4E+1
	dex
	bne outer14604
	ldy #0
final153
	lda ($4C),y
	sta ($4E),y
	iny
	cpy #232
	bne final153
	; Binary clause: GREATER
	lda frame
	; Compare with pure num / var optimization
	bcc binaryclausefailed19895
	lda #1; success
	jmp binaryclausefinished5447
binaryclausefailed19895
	lda #0 ; failed state
binaryclausefinished5447
logical_class_temp_var21726 = $54
	sta logical_class_temp_var21726
	; Binary clause: LESS
	lda frame
	; Compare with pure num / var optimization
	cmp #4
	bcs binaryclausefailed14771
	lda #1; success
	jmp binaryclausefinished11538
binaryclausefailed14771
	lda #0 ; failed state
binaryclausefinished11538
	and logical_class_temp_var21726
	cmp #1
	beq ConditionalTrueBlock12382
	jmp elsedoneblock18716
ConditionalTrueBlock12382
	lda $d018
	and #%11110001
	ora #8
	sta $d018
elsedoneblock18716
	; Binary clause: GREATER
	lda frame
	; Compare with pure num / var optimization
	cmp #4
	bcc binaryclausefailed28703
	lda #1; success
	jmp binaryclausefinished23811
binaryclausefailed28703
	lda #0 ; failed state
binaryclausefinished23811
logical_class_temp_var31322 = $54
	sta logical_class_temp_var31322
	; Binary clause: LESS
	lda frame
	; Compare with pure num / var optimization
	cmp #8
	bcs binaryclausefailed30333
	lda #1; success
	jmp binaryclausefinished17673
binaryclausefailed30333
	lda #0 ; failed state
binaryclausefinished17673
	and logical_class_temp_var31322
	cmp #1
	beq ConditionalTrueBlock25667
	jmp elsedoneblock17035
ConditionalTrueBlock25667
	lda $d018
	and #%11110001
	ora #10
	sta $d018
elsedoneblock17035
	; Binary clause: GREATER
	lda frame
	; Compare with pure num / var optimization
	cmp #8
	bcc binaryclausefailed27644
	lda #1; success
	jmp binaryclausefinished32662
binaryclausefailed27644
	lda #0 ; failed state
binaryclausefinished32662
logical_class_temp_var32757 = $54
	sta logical_class_temp_var32757
	; Binary clause: LESS
	lda frame
	; Compare with pure num / var optimization
	cmp #12
	bcs binaryclausefailed20037
	lda #1; success
	jmp binaryclausefinished12859
binaryclausefailed20037
	lda #0 ; failed state
binaryclausefinished12859
	and logical_class_temp_var32757
	cmp #1
	beq ConditionalTrueBlock7711
	jmp elsedoneblock6868
ConditionalTrueBlock7711
	lda $d018
	and #%11110001
	ora #12
	sta $d018
elsedoneblock6868
	; Binary clause: GREATER
	lda frame
	; Compare with pure num / var optimization
	cmp #12
	bcc binaryclausefailed22190
	lda #1; success
	jmp binaryclausefinished1842
binaryclausefailed22190
	lda #0 ; failed state
binaryclausefinished1842
logical_class_temp_var288 = $54
	sta logical_class_temp_var288
	; Binary clause: LESS
	lda frame
	; Compare with pure num / var optimization
	cmp #16
	bcs binaryclausefailed30106
	lda #1; success
	jmp binaryclausefinished9040
binaryclausefailed30106
	lda #0 ; failed state
binaryclausefinished9040
	and logical_class_temp_var288
	cmp #1
	beq ConditionalTrueBlock27529
	jmp elsedoneblock12316
ConditionalTrueBlock27529
	lda $d018
	and #%11110001
	ora #14
	sta $d018
elsedoneblock12316
	; Assigning single variable : curBank
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda curBank
	clc
	adc #1
	 ; end add / sub var with constant
	
	and #1
	 ; end add / sub var with constant
	
	sta curBank
	; Binary clause Simplified: EQUALS
	; Compare with pure num / var optimization
	bne elseblock27446
ConditionalTrueBlock22648
	; Set bank
	lda #3
	sta $dd00
	jmp elsedoneblock23805
elseblock27446
	; Set bank
	lda #2
	sta $dd00
elsedoneblock23805

	rts
	
	
	; ***********  Defining procedure : SetupScreenShift
	;    Procedure type : User-defined procedure
	
SetupScreenShift

	; Assigning single variable : p1
	lda #<screen
	ldx #>screen
	sta p1
	stx p1+1
	; Assigning single variable : i
	lda #0
	sta i
for15006

	; Assigning single variable : k
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; 8 bit binop
	; Add/sub where right value is constant number
	lda i
	and #3
	 ; end add / sub var with constant
	
	asl
	asl
	asl
	asl
	asl
	asl
	
	sta k
	; Assigning single variable : y
	lda #0
	sta y
for5537

	; Assigning single variable : x
	lda #0
	sta x
for29658
	; Assigning single variable : p1
	; Optimizer: a = a +/- b
	; Load pointer array
	ldy x
	lda (p1),y
	clc
	adc k
	ldy x
	sta (p1),y
	inc x
	lda #40
	cmp x
	bne for29658
forLoopDone9930
	lda #40
	clc
	adc p1
	bcc incscreenx2306
	inc p1 +1
incscreenx2306
	sta p1

	inc y
	lda #25
	cmp y
	bne for5537
forLoopDone31115

	inc i
	lda #16
	cmp i
	bne for15006
forLoopDone24626

	rts
	
	
	; ***********  Defining procedure : RasterMain
	;    Procedure type : User-defined procedure
	
RasterMain

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	jsr SetScreen
	; Binary clause Simplified: EQUALS
	; 8 bit binop
	; Add/sub where right value is constant number
	lda time
	and #3
	 ; end add / sub var with constant
	
	; Compare with pure num / var optimization
	bne elsedoneblock26924
ConditionalTrueBlock5021
	; Assigning single variable : frame
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda frame
	clc
	adc #1
	 ; end add / sub var with constant
	
	and #15
	 ; end add / sub var with constant
	
	sta frame
elsedoneblock26924
	inc time
	; CloseIRQ
	pla
	tay
	pla
	tax
	pla

	rti
block41

	; Disable interrupts
	ldy #$7f    ; $7f = %01111111
	sty $dc0d   ; Turn off CIAs Timer interrupts
	sty $dd0d   ; Turn off CIAs Timer interrupts
	lda $dc0d   ; cancel all CIA-IRQs in queue/unprocessed
	lda $dd0d   ; cancel all CIA-IRQs in queue/unprocessed
	
	; Set Memory Config
	lda $01
	and #%11111000
	ora #%101
	sta $01
	jsr SetupScreenShift
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d020
	lda #0
	sta $d020
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d021
	sta $d021
	; Clear screen with offset
	lda #12
	ldx #$00
clearloop5829
	sta $0000+$d800,x
	sta $0100+$d800,x
	sta $0200+$d800,x
	sta $02e8+$d800,x
	dex
	bne clearloop5829
	; Multicolor mode
	lda #16
	ora $d016
	sta $d016
	; Assigning single variable : $d021
	lda #6
	sta $d021+2
	; Assigning single variable : $d021
	lda #1
	sta $d021+1
	; RasterIRQ : Hook a procedure
	lda #0
	sta $d012
	lda #<RasterMain
	sta $fffe
	lda #>RasterMain
	sta $ffff
	; Enable raster IRQ
	lda $d01a
	ora #$01
	sta $d01a
	lda #$1B
	sta $d011
	asl $d019
	cli
	jmp * ; loop like (?/%

EndSymbol
	org $2000
charsetBank1
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///data/example4_chardata.bin"
	org $6000
charsetBank2
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///data/example4_chardata.bin"
	org $8000
screen
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Fjong///data/example4_screendata.bin"
