 processor 6502

	ORG $1201
	.byte    $0E, $08, $0A, $00, $9E, $20, $28
	.byte   $34,$36,$32,$34
	.byte    $29, $00, $00, $00

	ORG $1210
MyProgram
	jmp block18718
ok	dc.b	0
i	dc.b	0
j	dc.b	0
k	dc.b	0
m	dc.b	0
dx	dc.b	0
dy	dc.b	0
time	dc.b	0
l	dc.b	0
curFrame	dc.b	0
val	dc.b	0
g0	dc.b	0
g1	dc.b	0
c	dc.b	0
maxFrames	dc.b	0
pass	dc.b	0
hasTimeStamps	dc.b	
compressionType	dc.b	
endChar	dc.b	
skipChar	dc.b	
zp	= $02
cp	= $04
	
	
	; ***********  Defining procedure : init16x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
divisor = $4c     ;$59 used for hi-byte
dividend = $4e	  ;$fc used for hi-byte
remainder = $50	  ;$fe used for hi-byte
result = $4e ;save memory by reusing divident to store the result
divide16x8	lda #0	        ;preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        ;repeat for each bit: ...
divloop16	asl dividend	;dividend lb & hb*2, msb -> Carry
	rol dividend+1
	rol remainder	;remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor	;substract divisor to see if it fits in
	tay	        ;lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip16	;if carry=0 then divisor didn't fit in yet
	sta remainder+1	;else save substraction result as new remainder,
	sty remainder
	inc result	;and INCrement result cause divisor fit in 1 times
skip16	dex
	bne divloop16
	rts
	rts
	
	
	; ***********  Defining procedure : init16x8mul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
mul16x8_num1Hi = $4c
mul16x8_num1 = $4e
mul16x8_num2 = $50
mul16x8_procedure
	lda #$00
	ldy #$00
	sty mul16x8_num1Hi  ; remove this line for 16*8=16bit multiply
	beq mul16x8_enterLoop
mul16x8_doAdd
	clc
	adc mul16x8_num1
	tax
	tya
	adc mul16x8_num1Hi
	tay
	txa
mul16x8_loop
	asl mul16x8_num1
	rol mul16x8_num1Hi
mul16x8_enterLoop  ; accumulating multiply entry point (enter with .A=lo, .Y=hi)
	lsr mul16x8_num2
	bcs mul16x8_doAdd
	bne mul16x8_loop
	rts
mul16x8_def_end
	rts
	
	
	; ***********  Defining procedure : init8x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
div8x8_c = $4c
div8x8_d = $4e
div8x8_e = $50
	; Normal 8x8 bin div
div8x8_procedure
	lda #$00
	ldx #$07
	clc
div8x8_loop1 rol div8x8_d
	rol
	cmp div8x8_c
	bcc div8x8_loop2
	sbc div8x8_c
div8x8_loop2 dex
	bpl div8x8_loop1
	rol div8x8_d
	lda div8x8_d
	rts
div8x8_def_end
	rts
	
	
	; ***********  Defining procedure : initeightbitmul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
multiplier = $4c
multiplier_a = $4e
multiply_eightbit
	cpx #$00
	beq mul_end
	dex
	stx $4e
	lsr
	sta multiplier
	lda #$00
	ldx #$08
mul_loop
	bcc mul_skip
mul_mod
	adc multiplier_a
mul_skip
	ror
	ror multiplier
	dex
	bne mul_loop
	ldx multiplier
	rts
mul_end
	txa
	rts
multiply_eightbit26919
	rts
	
	
	; ***********  Defining procedure : initmoveto
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
	jmp moveto18259
screenmemory =  $fe
screen_x = $4c
screen_y = $4e
SetScreenPosition
	sta screenmemory+1
	lda #0
	sta screenmemory
	ldy screen_y
	beq sydone
syloop
	clc
	adc #22
	bcc sskip
	inc screenmemory+1
sskip
	dey
	bne syloop
sydone
	ldx screen_x
	beq sxdone
	clc
	adc screen_x
	bcc sxdone
	inc screenmemory+1
sxdone
	sta screenmemory
	rts
moveto18259
	rts
	
	
	; ***********  Defining procedure : ReadAnimationHeader
	;    Procedure type : User-defined procedure
	
 ; Temp vars section
 ; Temp vars section ends
ReadAnimationHeader

	; Assigning single variable : zp
	lda #0
	ldx #48
	sta zp
	stx zp+1
	; Assigning single variable : maxFrames
	; Load pointer array
	ldy #2
	lda (zp),y
	
	sta maxFrames
	; Assigning single variable : compressionType
	; Load pointer array
	ldy #3
	lda (zp),y
	
	sta compressionType
	; Assigning single variable : hasTimeStamps
	; Load pointer array
	ldy #4
	lda (zp),y
	
	sta hasTimeStamps
	; Assigning single variable : endChar
	; Load pointer array
	ldy #5
	lda (zp),y
	
	sta endChar
	; Assigning single variable : skipChar
	; Load pointer array
	ldy #6
	lda (zp),y
	
	sta skipChar
	lda #7
	clc
	adc zp
	bcc incscreenx14609
	inc zp +1
incscreenx14609
	sta zp
	; Assigning single variable : curFrame
	lda #0
	sta curFrame

	rts
	
	
	; ***********  Defining procedure : RenderNextPackedFrameCompressionType2
	;    Procedure type : User-defined procedure
	
RenderNextPackedFrameCompressionType2

	; Assigning single variable : m
	lda #0
	sta m
	; Assigning single variable : dy
	sta dy
	; Assigning single variable : dx
	lda #1
	sta dx
	clc
	adc zp
	bcc incscreenx21479
	inc zp +1
incscreenx21479
	sta zp
	; Assigning single variable : i
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta i
	; Assigning single variable : g0
	lda #0
	sta g0
	; Assigning single variable : pass
	sta pass
for22716
forLoopFix2317

	; Binary clause Simplified: EQUALS
	lda pass
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock17843
ConditionalTrueBlock12258
	; Assigning single variable : screenmemory
	lda #0
	ldx #148
	sta screenmemory
	stx screenmemory+1
elsedoneblock17843
	; Binary clause Simplified: EQUALS
	lda pass
	; Compare with pure num / var optimization
	bne elsedoneblock12937
ConditionalTrueBlock18140
	; Assigning single variable : screenmemory
	lda #0
	ldx #28
	sta screenmemory
	stx screenmemory+1
elsedoneblock12937
while6097
	; Binary clause Simplified: NOTEQUALS
	lda g0
	; Compare with pure num / var optimization
	cmp endChar
	beq elsedoneblock21817
ConditionalTrueBlock9551

	; Binary clause Simplified: EQUALS
	; Load pointer array
	ldy #0
	lda (zp),y
	
	; Compare with pure num / var optimization
	cmp skipChar
	bne elseblock6292
ConditionalTrueBlock27393

	; Assigning single variable : k
	; Load pointer array
	ldy #1
	lda (zp),y
	
	sta k
	clc
	adc screenmemory
	bcc incscreenx8705
	inc screenmemory +1
incscreenx8705
	sta screenmemory
	lda #2
	clc
	adc zp
	bcc incscreenx14713
	inc zp +1
incscreenx14713
	sta zp

	jmp elsedoneblock14962
elseblock6292

	; Assigning single variable : screenmemory
	; 8 bit binop
	; Add/sub where right value is constant number
	; Load pointer array
	ldy #0
	lda (zp),y
	
	clc
	adc #128
	 ; end add / sub var with constant
	
	ldy #0
	sta (screenmemory),y
	lda #1
	clc
	adc screenmemory
	bcc incscreenx18913
	inc screenmemory +1
incscreenx18913
	sta screenmemory
	lda #1
	clc
	adc zp
	bcc incscreenx6693
	inc zp +1
incscreenx6693
	sta zp

elsedoneblock14962
	; Assigning single variable : g0
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta g0

	jmp while6097
elsedoneblock21817
	; Assigning single variable : dx
	lda #0
	sta dx
	lda #1
	clc
	adc zp
	bcc incscreenx19664
	inc zp +1
incscreenx19664
	sta zp
	; Assigning single variable : g0
	lda #0
	sta g0

	inc pass
	lda #2
	cmp pass
	beq forLoopDone26134
	jmp for22716
forLoopDone26134
	; Binary clause Simplified: EQUALS
	lda hasTimeStamps
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock14381
ConditionalTrueBlock28995
	lda #1
	clc
	adc zp
	bcc incscreenx21768
	inc zp +1
incscreenx21768
	sta zp
elsedoneblock14381
	inc curFrame

	rts
	
	
	; ***********  Defining procedure : RenderNextPackedFrameCompressionType3
	;    Procedure type : User-defined procedure
	
RenderNextPackedFrameCompressionType3

	; Assigning single variable : m
	lda #0
	sta m
	; Assigning single variable : dy
	sta dy
	; Assigning single variable : dx
	lda #1
	sta dx
	; Assigning single variable : i
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta i
	; Assigning single variable : g0
	lda #0
	sta g0
	; Assigning single variable : pass
	sta pass
for22511
forLoopFix16211

	; Binary clause Simplified: EQUALS
	lda pass
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock20785
ConditionalTrueBlock3293
	; Assigning single variable : screenmemory
	lda #255
	ldx #147
	sta screenmemory
	stx screenmemory+1
elsedoneblock20785
	; Binary clause Simplified: EQUALS
	lda pass
	; Compare with pure num / var optimization
	bne elsedoneblock9270
ConditionalTrueBlock10555
	; Assigning single variable : screenmemory
	lda #255
	ldx #27
	sta screenmemory
	stx screenmemory+1
elsedoneblock9270
while14631
	; Binary clause Simplified: NOTEQUALS
	lda g0
	; Compare with pure num / var optimization
	cmp endChar
	beq elsedoneblock18040
ConditionalTrueBlock13640

	; Assigning single variable : g1
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta g1
	; Assigning single variable : i
	; 8 bit binop
	; Add/sub where right value is constant number
	; Load pointer array
	ldy #1
	lda (zp),y
	
	clc
	adc #128
	 ; end add / sub var with constant
	
	sta i
	ldy #0
fill12796
	sta (screenmemory),y
	iny
	cpy g1
	bne fill12796
	lda g1
	clc
	adc screenmemory
	bcc incscreenx10312
	inc screenmemory +1
incscreenx10312
	sta screenmemory
	lda #2
	clc
	adc zp
	bcc incscreenx7262
	inc zp +1
incscreenx7262
	sta zp
	; Assigning single variable : g0
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta g0

	jmp while14631
elsedoneblock18040
	; Assigning single variable : dx
	lda #0
	sta dx
	lda #1
	clc
	adc zp
	bcc incscreenx25052
	inc zp +1
incscreenx25052
	sta zp
	; Assigning single variable : g0
	lda #0
	sta g0

	inc pass
	lda #2
	cmp pass
	beq forLoopDone11754
	jmp for22511
forLoopDone11754
	; Binary clause Simplified: EQUALS
	lda hasTimeStamps
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock32557
ConditionalTrueBlock23987
	lda #1
	clc
	adc zp
	bcc incscreenx5450
	inc zp +1
incscreenx5450
	sta zp
elsedoneblock32557
	inc curFrame

	rts
block18718

	; Assigning memory location (poke replacement)
	; Assigning single variable : $900f
	lda #0
	sta $900f
	lda $9005
	and #%00001111
	ora #%11110000
	sta $9005
while27182
	; Binary clause Simplified: EQUALS
	lda #1
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock24099
ConditionalTrueBlock7301

	; Binary clause Simplified: EQUALS
	lda compressionType
	; Compare with pure num / var optimization
	cmp #3
	bne elsedoneblock27577
ConditionalTrueBlock666
	jsr RenderNextPackedFrameCompressionType3
elsedoneblock27577
	; Binary clause Simplified: EQUALS
	lda compressionType
	; Compare with pure num / var optimization
	cmp #2
	bne elsedoneblock2872
ConditionalTrueBlock23292
	jsr RenderNextPackedFrameCompressionType2
elsedoneblock2872
	; Assigning single variable : i
	lda #0
	sta i
for11153
	; wait for raster
	ldx #0
	cpx $9004
	bne *-3
	inc i
	lda #25
	cmp i
	bne for11153
forLoopDone24395
	; Binary clause Simplified: GREATER
	lda curFrame
	; Compare with pure num / var optimization
	cmp maxFrames
	bcc elsedoneblock13993
ConditionalTrueBlock22908

	jsr ReadAnimationHeader

elsedoneblock13993

	jmp while27182
elsedoneblock24099
	jmp * ; loop like (?/%

EndSymbol
	org $3000
movie
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/Vic20/tutorials///movie/movie.trm"
